#include <stdint.h>

#define SPI_MEM_WRITE_EN 0x06
#define SPI_MEM_READ_ARRAY 0x03
#define SPI_MEM_WRITE 0x02
#define SPI_MEM_BLOCK_ERASE_4KB 0x20
#define SPI_MEM_STATUS1 0x05;

#define BLOCK_SIZE 4096

#define START_BYTE 0x41
#define PREAM_BYTE 0x41
#define PREAM_LEN 5


void mem_read_16b(int *data_buf, int32_t wav_mem_address);
void mem_erase_4k(int32_t wav_mem_address);
void mem_write_page(int *page_buf, int32_t mem_address);
void mem_read_page(int *page_buf, int32_t mem_address);
void wait_transmit(void);
void wait_receive(void);

void modmem_write(int uart_mod_start_byte);
void modmem_erase_4k(int32_t block4k_mem_address);
void modmem_wait_transmit(void);
void modmem_wait_receive(void);
