/*
 * File:   main.c
 * Author: michal
 *
 * Created on 18 września 2016, 15:58
 */


#include "xc.h"
#include "config_bits.h"
#include "ports.h"
#include "init.h"
#include "ui.h"


volatile int g_key_numb = -1;
int led_matrix[LED_SIZE_X * LED_SIZE_Y] = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};

struct analog_cal_struct analog_cal[2] = {{1, 0, 1, 0}, {1, 0, 1, 0}};
struct wave_param_struct wave_param[2] = {{1, 1000, 0, 0.5, 1, 0, 1, 0, 0, 50, 10, 50, 1, 0, 0}, {1, 1000, 0, 0.5, 1, 0, 1, 0, 0, 50, 10, 50, 1, 1, 0}};
struct fpga_params_struct fpga_params = {0, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};


int main(void)
{
    init_clock();
    init_ports();
    init_timer();
    init_spi_wave_memory();
    init_spi_mod_memory();
    init_uart();
    init_contrast_pwm();
    init_lcd();
    init_calibration(analog_cal);
    menu_main();   //stay here forever - main menu or submenus

    return 0;
}
