#define FOSC    (32000000ULL)
#define FCY     (FOSC/2)

#include <xc.h>


#define LCD_DB4_LAT LATDbits.LATD0
#define LCD_DB5_LAT LATDbits.LATD1
#define LCD_DB6_LAT LATDbits.LATD2
#define LCD_DB7_LAT LATDbits.LATD3
#define LCD_CONTR_LAT LATDbits.LATD4
#define LCD_E_LAT LATDbits.LATD5
#define LCD_RS_LAT LATDbits.LATD6
//-------------------------------
#define LCD_DB4_TRIS TRISDbits.TRISD0
#define LCD_DB5_TRIS TRISDbits.TRISD1
#define LCD_DB6_TRIS TRISDbits.TRISD2
#define LCD_DB7_TRIS TRISDbits.TRISD3
#define LCD_CONTR_TRIS TRISDbits.TRISD4
#define LCD_E_TRIS TRISDbits.TRISD5
#define LCD_RS_TRIS TRISDbits.TRISD6
//-------------------------------
//-------------------------------

#define DIG_IN_50R_EN_LAT LATGbits.LATG7
#define DIG_OUT_50R_DIS_LAT LATFbits.LATF0
#define DIG_OUT_LO_Z_DIS_LAT LATFbits.LATF1
//-------------------------------
#define DIG_IN_50R_EN_TRIS TRISGbits.TRISG7
#define DIG_OUT_50R_DIS_TRIS TRISFbits.TRISF0
#define DIG_OUT_LO_Z_DIS_TRIS TRISFbits.TRISF1
//-------------------------------
//-------------------------------

//#define PLL_A_S0_LAT LATDbits.LATD8
//#define PLL_A_S1_LAT LATDbits.LATD9
//#define PLL_B_S0_LAT LATDbits.LATD10
//#define PLL_B_S1_LAT LATDbits.LATD11
//-------------------------------
//#define PLL_A_S0_TRIS TRISDbits.TRISD8
//#define PLL_A_S1_TRIS TRISDbits.TRISD9
//#define PLL_B_S0_TRIS TRISDbits.TRISD10
//#define PLL_B_S1_TRIS TRISDbits.TRISD11
//-------------------------------
//-------------------------------

#define INT_DATA_0_LAT LATEbits.LATE0
#define INT_DATA_1_LAT LATEbits.LATE1
#define INT_DATA_2_LAT LATEbits.LATE2
#define INT_DATA_3_LAT LATEbits.LATE3
#define INT_DATA_4_LAT LATEbits.LATE4
#define INT_DATA_5_LAT LATEbits.LATE5
#define INT_DATA_6_LAT LATEbits.LATE6
#define INT_DATA_7_LAT LATEbits.LATE7
#define INT_WR_LAT LATAbits.LATA6
#define INT_DCLK_LAT LATAbits.LATA7
//-------------------------------
#define INT_DATA_0_TRIS TRISEbits.TRISE0
#define INT_DATA_1_TRIS TRISEbits.TRISE1
#define INT_DATA_2_TRIS TRISEbits.TRISE2
#define INT_DATA_3_TRIS TRISEbits.TRISE3
#define INT_DATA_4_TRIS TRISEbits.TRISE4
#define INT_DATA_5_TRIS TRISEbits.TRISE5
#define INT_DATA_6_TRIS TRISEbits.TRISE6
#define INT_DATA_7_TRIS TRISEbits.TRISE7
#define INT_WR_TRIS TRISAbits.TRISA6
#define INT_DCLK_TRIS TRISAbits.TRISA7
//-------------------------------
//-------------------------------

#define OUT_EN_A_LAT LATFbits.LATF4
#define OUT_ATTEN_DIS_A_LAT LATFbits.LATF5
#define OUT_EN_B_LAT LATFbits.LATF12
#define OUT_ATTEN_DIS_B_LAT LATFbits.LATF13
//-------------------------------
#define OUT_EN_A_TRIS TRISFbits.TRISF4
#define OUT_ATTEN_DIS_A_TRIS TRISFbits.TRISF5
#define OUT_EN_B_TRIS TRISFbits.TRISF12
#define OUT_ATTEN_DIS_B_TRIS TRISFbits.TRISF13
//-------------------------------
//-------------------------------

#define LED_X0_LAT LATGbits.LATG12
#define LED_X1_LAT LATGbits.LATG13
#define LED_X2_LAT LATGbits.LATG14
#define LED_X3_LAT LATGbits.LATG15
#define LED_Y0_LAT LATGbits.LATG0
#define LED_Y1_LAT LATGbits.LATG1
#define LED_Y2_LAT LATGbits.LATG2
#define LED_Y3_LAT LATGbits.LATG3
//-------------------------------
#define LED_X0_TRIS TRISGbits.TRISG12
#define LED_X1_TRIS TRISGbits.TRISG13
#define LED_X2_TRIS TRISGbits.TRISG14
#define LED_X3_TRIS TRISGbits.TRISG15
#define LED_Y0_TRIS TRISGbits.TRISG0
#define LED_Y1_TRIS TRISGbits.TRISG1
#define LED_Y2_TRIS TRISGbits.TRISG2
#define LED_Y3_TRIS TRISGbits.TRISG3
//-------------------------------
//-------------------------------

#define KEY_X0_LAT LATBbits.LATB10
#define KEY_X1_LAT LATBbits.LATB11
#define KEY_X2_LAT LATBbits.LATB12
#define KEY_X3_LAT LATBbits.LATB13
#define KEY_X4_LAT LATBbits.LATB14
#define KEY_X5_LAT LATBbits.LATB15
#define KEY_Y0_PORT PORTBbits.RB4
#define KEY_Y1_PORT PORTBbits.RB5
#define KEY_Y2_PORT PORTBbits.RB6
#define KEY_Y3_PORT PORTBbits.RB7
#define KEY_Y4_PORT PORTBbits.RB8
#define KEY_Y5_PORT PORTBbits.RB9
//-------------------------------
#define KEY_X0_TRIS TRISBbits.TRISB10
#define KEY_X1_TRIS TRISBbits.TRISB11
#define KEY_X2_TRIS TRISBbits.TRISB12
#define KEY_X3_TRIS TRISBbits.TRISB13
#define KEY_X4_TRIS TRISBbits.TRISB14
#define KEY_X5_TRIS TRISBbits.TRISB15
#define KEY_Y0_TRIS TRISBbits.TRISB4
#define KEY_Y1_TRIS TRISBbits.TRISB5
#define KEY_Y2_TRIS TRISBbits.TRISB6
#define KEY_Y3_TRIS TRISBbits.TRISB7
#define KEY_Y4_TRIS TRISBbits.TRISB8
#define KEY_Y5_TRIS TRISBbits.TRISB9
//-------------------------------
//-------------------------------

#define ROT_A_PORT PORTAbits.RA14
#define ROT_B_PORT PORTAbits.RA15
//-------------------------------
#define ROT_A_TRIS TRISAbits.TRISA14
#define ROT_B_TRIS TRISAbits.TRISA15
//-------------------------------
//-------------------------------

#define WAVMEM_CS_LAT LATBbits.LATB2
//#define WAVMEM_SCLK_LAT LATFbits.LATF6
//#define WAVMEM_SO_LAT LATFbits.LATF7
//#define WAVMEM_SI_LAT LATFbits.LATF8
//-------------------------------
#define WAVMEM_CS_TRIS TRISBbits.TRISB2
//#define WAVMEM_SCLK_TRIS TRISFbits.TRISF6
//#define WAVMEM_SO_TRIS TRISFbits.TRISF7
//#define WAVMEM_SI_TRIS TRISFbits.TRISF8
//-------------------------------
//-------------------------------

#define MODMEM_CS_LAT LATGbits.LATG9
//-------------------------------
#define MODMEM_CS_TRIS TRISGbits.TRISG9
//-------------------------------
//-------------------------------

#define AUX1_PORT PORTCbits.RC1
#define AUX2_PORT PORTCbits.RC2
//-------------------------------
#define AUX1_TRIS TRISCbits.TRISC1
#define AUX2_TRIS TRISCbits.TRISC2
//-------------------------------
//-------------------------------