#include <stdint.h>
#ifndef STRUCTURES
#define STRUCTURES

#define FUNCT_SIN 1
#define FUNCT_RECT 2
#define FUNCT_TRI 3
#define FUNCT_NOISE 4
#define FUNCT_ARB 5

#define MOD_NONE 0
#define MOD_AM 1
#define MOD_AM_SC 2
#define MOD_FM 3
#define MOD_PM 4
#define MOD_PWM 5

#define TRIG_WAV1 0
#define TRIG_WAV2 1
#define TRIG_MOD1 2
#define TRIG_MOD2 3
#define TRIG_NONE 4


struct fpga_params_struct
{
    int64_t clk_phase_acc_conf;
    int64_t clk_pll_conf;
    int32_t cnt_step;
    int32_t addr_phase;
    int32_t mod_pwm;
    int32_t amplitude;
    int32_t offset;
    int32_t dds_mode;
    int32_t mod_am;
    int32_t mod_fm;
    int32_t mod_ampl;
    int32_t mod_phase;
    int32_t mod_conf;
    int32_t mod_freq;
    int32_t mod_dev_power;
    int32_t mod_wave_num;
    int32_t in_offset_data;
    int32_t in_amplitude_data;
    int32_t trig_sel;
};

struct wave_param_struct
{
    int function;
    double freqency;
    double phase;
    double symmetry;
    double amplitude;
    double offset;
    int wave_num;
    int atten20db;

    int mod_type;
    double mod_ampl;
    double mod_dev;
    double mod_freq;
    int32_t mod_wave_num;
    int32_t mod_ext_not_int;
    int32_t mod_write_not_read;
};

struct analog_cal_struct
{
    double out_amplitude;
    double out_offset;
    double in_amplitude;
    double in_offset;
};


#endif
