#include <xc.h>
#include "structs.h"

#define KEYB_SIZE_X 6
#define KEYB_SIZE_Y 6
#define LED_SIZE_X 4
#define LED_SIZE_Y 4
#define DEBOUNCE_CHECKS 5

#define KEY_CONTEXT_1 6
#define KEY_CONTEXT_2 12
#define KEY_CONTEXT_3 18
#define KEY_CONTEXT_4 24
#define KEY_CONTEXT_UP 0
#define KEY_CONTEXT_DOWN 30
#define KEY_LEFT 29
#define KEY_RIGHT 35
#define KEY_CH1_ON 17
#define KEY_CH2_ON 23

#define KEY_FUNCT_SIN 1
#define KEY_FUNCT_RECT 7
#define KEY_FUNCT_TRI 13
#define KEY_FUNCT_NOISE 19
#define KEY_FUNCT_ARB 25
#define KEY_UTILS 31
#define KEY_MOD_SET 28
#define KEY_MOD_ON 34
#define KEY_SELECT_CHANNEL_1 5
#define KEY_SELECT_CHANNEL_2 11

#define KEY_0 4
#define KEY_1 15
#define KEY_2 21
#define KEY_3 27
#define KEY_4 26
#define KEY_5 32
#define KEY_6 3
#define KEY_7 2
#define KEY_8 8
#define KEY_9 14
#define KEY_POINT 10
#define KEY_MINUS 16

#define KEY_RETURN 22
#define KEY_EXIT 20
#define KEY_CLEAR 9
#define KEY_BACKSPACE 33

#define LED_FUNCT_SIN 3
#define LED_FUNCT_RECT 2
#define LED_FUNCT_TRI 1
#define LED_FUNCT_NOISE 0
#define LED_FUNCT_ARB 7
#define LED_UTILS 6
#define LED_MOD_ON 4
#define LED_MOD_SET 5
#define LED_CH1 11
#define LED_CH2 10
#define LED_CH1_ON 13
#define LED_CH2_ON 12
#define LED_OV 14
#define LED_BUSY 15
#define LED_FIX_F 9
#define LED_VAR_F 8

#define KEY_ONE_OF_NUMERIC_KEYS ((g_key_numb == KEY_0) || (g_key_numb == KEY_1)\
                            ||   (g_key_numb == KEY_2) || (g_key_numb == KEY_3)\
                            ||   (g_key_numb == KEY_4) || (g_key_numb == KEY_5)\
                            ||   (g_key_numb == KEY_6) || (g_key_numb == KEY_7)\
                            ||   (g_key_numb == KEY_8) || (g_key_numb == KEY_9)\
                            ||   (g_key_numb == KEY_POINT) || (g_key_numb == KEY_MINUS))
#define CONT_LINE_NUM(k) ((k == KEY_CONTEXT_1) ? 1 : ((k == KEY_CONTEXT_2) ? 2 : ((k == KEY_CONTEXT_3) ? 3 : 4)))


void menu_main(void);
void menu_mod(int channel, struct wave_param_struct *wave_param, struct fpga_params_struct *p_fpga_params);
void menu_utils(struct fpga_params_struct *p_fpga_params);
void menu_cal(struct fpga_params_struct *p_fpga_params);

void knob(double *initial_number, int disp_line, int channel);
int enter_uint(int initial_number, int disp_line);
double enter_float(double initial_number, int disp_line);
void led_funct_set(int funct);
/*void set_initial_settings(int *channel, int *funct, int *context_position, int *context_screens,
struct analog_cal_struct analog_cal[2], struct wave_param_struct wave_param[2], struct fpga_params_struct fpga_params);
void save_settings(int *channel, int *funct, int *context_position, int *context_screens,
struct analog_cal_struct *analog_cal, struct wave_param_struct *wave_param, struct fpga_params_struct fpga_params);
*/
