----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    12:26:37 05/03/2017 
-- Design Name: 
-- Module Name:    dig_io_mux - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity dig_io_mux is
    Port ( trig_1_wave : in  STD_LOGIC;
           trig_2_wave : in  STD_LOGIC;
           trig_1_mod : in  STD_LOGIC;
           trig_2_mod : in  STD_LOGIC;
           wr_en : in  STD_LOGIC;
           wr : in  STD_LOGIC;
           dig_out_sel : in  STD_LOGIC_VECTOR (3 downto 0);
           dig_out : out  STD_LOGIC);
end dig_io_mux;

architecture Behavioral of dig_io_mux is

	signal dig_out_sel_sig : std_logic_vector(3 downto 0) := (others => '0');

begin


	------------------------------------------------------------------------
	--latch values received from microcontroller
	------------------------------------------------------------------------
	latch: process(wr) is
	begin
		if rising_edge(wr) then	--warning - this is not synchronous with fpga logic
			if wr_en = '1' then
				dig_out_sel_sig <= dig_out_sel;
			end if;
		end if;
	end process latch;
	------------------------------------------------------------------------
	

	dig_out <= 	trig_1_wave when dig_out_sel_sig = "0000" else
					trig_2_wave when dig_out_sel_sig = "0001" else
					trig_1_mod when dig_out_sel_sig = "0010" else
					trig_2_mod when dig_out_sel_sig = "0011" else
					'0';

end Behavioral;

