----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    23:21:35 07/19/2016 
-- Design Name: 
-- Module Name:    pwm_comparator - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity pwm_comparator is
    Port ( clk : in  STD_LOGIC;
           wr_en : in  STD_LOGIC;
           wr : in  STD_LOGIC;
           pwm_on : in  STD_LOGIC;
           wave_in : in  STD_LOGIC_VECTOR (15 downto 0);
           thresh : in  STD_LOGIC_VECTOR (15 downto 0);
           wave_out : out  STD_LOGIC_VECTOR (15 downto 0));
end pwm_comparator;

architecture Behavioral of pwm_comparator is
	signal pwm_on_sig : std_logic := '0';
	signal wave_in_sig : std_logic_vector(15 DOWNTO 0);
begin

	------------------------------------------------------------------------
	-- latch values received from microcontroller
	------------------------------------------------------------------------
	latch: process(wr) is
	begin
		if rising_edge(wr) then
			if wr_en = '1' then
				pwm_on_sig <= pwm_on;
			end if;
		end if;
	end process latch;
	------------------------------------------------------------------------
	

	------------------------------------------------------------------------
	-- comparator used to generate pwm from triangle
	------------------------------------------------------------------------
	pwm: process(clk) is
	begin
		if rising_edge(clk) then
			wave_in_sig <= wave_in;
			if pwm_on_sig = '0' then
				wave_out <= wave_in_sig;
			elsif pwm_on_sig = '1' then
				if signed(wave_in_sig) < signed(thresh) then
					wave_out <= "0111111111111111";
				elsif signed(wave_in_sig) > signed(thresh) then
					wave_out <= "1000000000000000";
				end if;
			end if;
		end if;
	end process pwm;
	------------------------------------------------------------------------
				
	
end Behavioral;

