----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    22:02:38 03/29/2017 
-- Design Name: 
-- Module Name:    sync_bus - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity sync_bus is
    Port ( clk_data_in : in  STD_LOGIC;
           clk_data_out : in  STD_LOGIC;
           data_in : in  STD_LOGIC_VECTOR (31 downto 0);
           data_out : out  STD_LOGIC_VECTOR (31 downto 0));
end sync_bus;

architecture Behavioral of sync_bus is

	signal s_ena1 : std_logic := '0';
	signal s_ena2 : std_logic := '0';
	signal data_in_latched : std_logic_vector(31 downto 0) := (others => '0');
	signal data_out_sig : std_logic_vector(31 downto 0) := (others => '0');

begin


sync_in: process(clk_data_in) is
begin
if rising_edge(clk_data_in) then
	data_in_latched <= data_in;
end if;
end process sync_in;

sync_ena: process(clk_data_out) is
begin
if rising_edge(clk_data_out) then
	s_ena1 <= clk_data_in;
	s_ena2 <= s_ena1;
end if;
end process sync_ena;

sync_out: process(clk_data_out) is
begin
if rising_edge(clk_data_out) then
	if s_ena2 = '1' then
		data_out_sig <= data_in_latched;
	else
		data_out_sig <= data_out_sig;
	end if;
end if;
data_out <= data_out_sig;
end process sync_out;


end Behavioral;

