-- Vhdl test bench created from schematic /home/michal/ELEKTRONIKA/gen_fpga/fpga/fpga_v1/top.sch - Wed Jul 20 00:01:35 2016
--
-- Notes: 
-- 1) This testbench template has been automatically generated using types
-- std_logic and std_logic_vector for the ports of the unit under test.
-- Xilinx recommends that these types always be used for the top-level
-- I/O of a design in order to guarantee that the testbench will bind
-- correctly to the timing (post-route) simulation model.
-- 2) To use this template as your testbench, change the filename to any
-- name of your choice with the extension .vhd, and use the "Source->Add"
-- menu in Project Navigator to import the testbench. Then
-- edit the user defined section below, adding code to generate the 
-- stimulus for your design.
--
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL;
LIBRARY UNISIM;
USE UNISIM.Vcomponents.ALL;
use STD.textio.all; --Dont forget to include this library for file operations.
ENTITY top_top_sch_tb IS
END top_top_sch_tb;
ARCHITECTURE behavioral OF top_top_sch_tb IS 

   COMPONENT top
   PORT( wave_ext_clk	:	IN	STD_LOGIC; 
          f_mult	:	IN	STD_LOGIC; 
          wr_freq	:	IN	STD_LOGIC; 
          wr_step_phase	:	IN	STD_LOGIC; 
          tcxo_clk	:	IN	STD_LOGIC; 
          ext_data	:	IN	STD_LOGIC_VECTOR (15 DOWNTO 0); 
          ext_clk	:	IN	STD_LOGIC; 
          wave_out	:	OUT	STD_LOGIC_VECTOR (13 DOWNTO 0); 
          wr_ampl_offs	:	IN	STD_LOGIC; 
          WR_PWM_THRESH	:	IN	STD_LOGIC; 
          PWM_ON	:	IN	STD_LOGIC);
   END COMPONENT;

   SIGNAL wave_ext_clk	:	STD_LOGIC;
   SIGNAL f_mult	:	STD_LOGIC;
   SIGNAL wr_freq	:	STD_LOGIC;
   SIGNAL wr_step_phase	:	STD_LOGIC;
   SIGNAL tcxo_clk	:	STD_LOGIC;
   SIGNAL ext_data	:	STD_LOGIC_VECTOR (15 DOWNTO 0);
   SIGNAL ext_clk	:	STD_LOGIC;
   SIGNAL wave_out	:	STD_LOGIC_VECTOR (13 DOWNTO 0);
   SIGNAL wr_ampl_offs	:	STD_LOGIC;
   SIGNAL WR_PWM_THRESH	:	STD_LOGIC;
   SIGNAL PWM_ON	:	STD_LOGIC;
			  
   constant clk_period : time := 50 ns;

BEGIN

   UUT: top PORT MAP(
		wave_ext_clk => wave_ext_clk, 
		f_mult => f_mult, 
		wr_freq => wr_freq, 
		wr_step_phase => wr_step_phase, 
		tcxo_clk => tcxo_clk, 
		ext_data => ext_data, 
		ext_clk => ext_clk, 
		wave_out => wave_out, 
		wr_ampl_offs => wr_ampl_offs, 
		WR_PWM_THRESH => WR_PWM_THRESH, 
		PWM_ON => PWM_ON
   );

-- *** Test Bench - User Defined Section ***


	clk_proc: process
	begin
		tcxo_clk <= '0';
		wait for clk_period/2;  --for 0.5 ns signal is '0'.
		tcxo_clk <= '1';
		wait for clk_period/2;  --for next 0.5 ns signal is '1'.
	end process clk_proc;


   d_in : process
		variable mem_addr: unsigned(12 downto 0);
		variable mem_data: unsigned(17 downto 0);
   begin

		f_mult <= '0';
		wr_freq <= '0';
		wr_step_phase <= '0';
		wr_ampl_offs <= '0';
		wr_pwm_thresh <= '0';
		wave_ext_clk <= '0';
		pwm_on <= '0';
		ext_clk <= '0';
		clk_wav_gen <= '0';
		reset_wav_gen <= '0';
		wr_tri_coe <= '0';
		sin_tri_select <= '0';
		
		--freq set
		ext_data <= "0110000000000000";
		wait for 1 us;		
		ext_clk <= '1';
		wait for 1 us;
		ext_clk <= '0';
		ext_data <= "0000000000000000";
		wait for 1 us;
		ext_clk <= '1';
		wait for 1 us;
		wr_freq <= '1';
		wait for 1 us;
		wr_freq <= '0';
		ext_clk <= '0';		
		wait for 1 us;
		wait for 5 us;
		
		--step phase set
		ext_data <= "0000000000000100";
		wait for 1 us;		
		ext_clk <= '1';
		wait for 1 us;
		ext_clk <= '0';
		ext_data <= "0000000100000000";
		wait for 1 us;
		ext_clk <= '1';
		wait for 1 us;
		wr_step_phase <= '1';
		wait for 1 us;
		wr_step_phase <= '0';
		ext_clk <= '0';		
		wait for 1 us;
		wait for 5 us;

		--ampl offset set
		ext_data <= "0000000001000000";
		wait for 1 us;		
		ext_clk <= '1';
		wait for 1 us;
		ext_clk <= '0';
		ext_data <= "0100000000000000";
		wait for 1 us;
		ext_clk <= '1';
		wait for 1 us;
		wr_ampl_offs <= '1';
		wait for 1 us;
		wr_ampl_offs <= '0';
		ext_clk <= '0';		
		wait for 1 us;
		wait for 5 us;
		
		--memory generator scale offset set
		ext_data <= "0000000000000000";
		wait for 1 us;
		ext_clk <= '1';
		wait for 1 us;
		ext_clk <= '0';
		ext_data <= "0000000001101010";
		wait for 1 us;
		ext_clk <= '1';
		wait for 1 us;
		wr_tri_coe <= '1';
		wait for 1 us;
		wr_tri_coe <= '0';
		ext_clk <= '0';
		wait for 1 us;
		reset_wav_gen <= '1';
		wait for 1 us;
		reset_wav_gen <= '0';
		wait for 1 us;		
		
		for I in 0 to 2456 loop
			clk_wav_gen <= '0';
			wave_ext_clk <= '0';
			wait for 30 ns;
			clk_wav_gen <= '1';
			wait for 30 ns;
			wave_ext_clk <= '1';
			wait for 30 ns;
		end loop;		

		ext_data <= "0000000001000011";
		wait for 1 us;
		ext_clk <= '1';
		wait for 1 us;
		ext_clk <= '0';
		ext_data <= "1111111111010101";
		wait for 1 us;
		ext_clk <= '1';
		wait for 1 us;
		wr_tri_coe <= '1';
		wait for 1 us;
		wr_tri_coe <= '0';
		ext_clk <= '0';
		wait for 1 us;	

		wait for 1 us;	
		reset_wav_gen <= '1';
		wait for 1 us;
		reset_wav_gen <= '0';
		wait for 1 us;	
		
		for I in 2456 to 8191 loop
			clk_wav_gen <= '0';
			wave_ext_clk <= '0';
			wait for 30 ns;
			clk_wav_gen <= '1';
			wait for 30 ns;
			wave_ext_clk <= '1';
			wait for 30 ns;
		end loop;	


		
--		mem_addr := "0000000000000";
--		mem_data := "000000000000000000";
--		for I in 0 to 8191 loop
--			ext_data (14 downto 2) <= std_logic_vector (mem_addr);
--			ext_data (1 downto 0) <= std_logic_vector (mem_data (17 downto 16));
--			wait for 30 ns;
--			ext_clk <= '1';
--			wait for 30 ns;
--			ext_clk <= '0';
--			ext_data <= std_logic_vector (mem_data (15 downto 0));
--			wait for 30 ns;
--			ext_clk <= '1';
--			wait for 30 ns;
--			wave_ext_clk <= '1';
--			wait for 30 ns;
--			wave_ext_clk <= '0';
--			ext_clk <= '0';
--			wait for 30 ns;
--			mem_addr := mem_addr + 1;
--			mem_data := mem_data + 1;
--			wait for 30 ns;
--		end loop;

		

      wait; -- will wait forever
   end process d_in;
	
	
	
	
	--Write process
	process
		file file_pointer : text;
		variable line_content : character;
		variable line_num : line;
		variable i : integer := 0;
		variable char : character:='0';
		begin
			file_open(file_pointer,"./waveout",WRITE_MODE);     
			loop
				wait until rising_edge(tcxo_clk);
				
				if wave_out(13) = '1' then
					line_content := '1';
				else
					line_content := '0';
				end if;
				write(line_num,line_content);
				
				if wave_out(12) = '1' then
					line_content := '1';
				else
					line_content := '0';
				end if;
				write(line_num,line_content);
							
				if wave_out(11) = '1' then
					line_content := '1';
				else
					line_content := '0';
				end if;
				write(line_num,line_content);			
				
				if wave_out(10) = '1' then
					line_content := '1';
				else
					line_content := '0';
				end if;
				write(line_num,line_content);
							
				if wave_out(9) = '1' then
					line_content := '1';
				else
					line_content := '0';
				end if;
				write(line_num,line_content);			
				
				if wave_out(8) = '1' then
					line_content := '1';
				else
					line_content := '0';
				end if;
				write(line_num,line_content);
							
				if wave_out(7) = '1' then
					line_content := '1';
				else
					line_content := '0';
				end if;
				write(line_num,line_content);			
				
				if wave_out(6) = '1' then
					line_content := '1';
				else
					line_content := '0';
				end if;
				write(line_num,line_content);
							
				if wave_out(5) = '1' then
					line_content := '1';
				else
					line_content := '0';
				end if;
				write(line_num,line_content);
							
				if wave_out(4) = '1' then
					line_content := '1';
				else
					line_content := '0';
				end if;
				write(line_num,line_content);
							
				if wave_out(3) = '1' then
					line_content := '1';
				else
					line_content := '0';
				end if;
				write(line_num,line_content);
							
				if wave_out(2) = '1' then
					line_content := '1';
				else
					line_content := '0';
				end if;
				write(line_num,line_content);			
				
				if wave_out(1) = '1' then
					line_content := '1';
				else
					line_content := '0';
				end if;
				write(line_num,line_content);			

				if wave_out(0) = '1' then
					line_content := '1';
				else
					line_content := '0';
				end if;
				write(line_num,line_content);
				writeline (file_pointer,line_num);
				
				
			end loop;		
			file_close(file_pointer);
			wait;
	end process;
	
	
	
-- *** End Test Bench - User Defined Section ***

END;
