----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    23:23:38 07/05/2016 
-- Design Name: 
-- Module Name:    wave_counter - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity wave_counter is
    Port ( clk : in  STD_LOGIC;
           wr_en : in  STD_LOGIC;
           wr : in  STD_LOGIC;
           step : in  STD_LOGIC_VECTOR (12 downto 0);
           addr_out : out  STD_LOGIC_VECTOR (12 downto 0));
end wave_counter;

architecture Behavioral of wave_counter is
	signal addr_cnt : std_logic_vector(12 downto 0) := (others => '0');
	signal step_sig : std_logic_vector(12 downto 0) := (others => '0');
begin


	------------------------------------------------------------------------
	-- latch values received from microcontroller
	------------------------------------------------------------------------
	latch: process(wr) is
	begin
		if rising_edge(wr) then
			if wr_en = '1' then
				step_sig <= step;
			end if;
		end if;
	end process latch;
	------------------------------------------------------------------------


	------------------------------------------------------------------------
	-- address counter
	------------------------------------------------------------------------
	wave_cnt: process(clk) is
	begin
		if rising_edge(clk) then
			addr_cnt <= std_logic_vector(unsigned(addr_cnt) + unsigned(step_sig));
		end if;
	end process wave_cnt;
	addr_out <= addr_cnt;
	------------------------------------------------------------------------


end Behavioral;

