#include <stdio.h>   /* Standard input/output definitions */
#include <string.h>  /* String function definitions */
#include <unistd.h>  /* UNIX standard function definitions */
#include <fcntl.h>   /* File control definitions */
#include <errno.h>   /* Error number definitions */
#include <termios.h> /* POSIX terminal control definitions */
#include <stdint.h>


int main(void)
{
	int fd; /* File descriptor for the port */
	int n;
    struct termios tty;

	int32_t wavebuf[8192];
	char buf256[256];
	char wave_num;
	int i,j;

	wave_num = '4';
	
	FILE *file = fopen("wav_noise.csv", "r");
    if (file == NULL)
    {
        perror("Nie udalo sie otworzyc pliku notatki.txt");
        return 1;
    }
	for(i = 0; i < 8192; ++i)
		fscanf(file, "%d", wavebuf + i);      
    fclose(file);
	
	//for(i = 0; i < 8192; ++i)
	//	printf ("%d\n", *(wavebuf + i)); 	
	

	fd = open("/dev/ttyACM0", O_RDWR | O_NOCTTY | O_NDELAY);
	if (fd == -1)
		perror("open_port: Unable to open /dev/ttyACM0 - ");
	else
    	fcntl(fd, F_SETFL, 0);

	tcgetattr(fd, &tty);
    cfsetospeed(&tty, B9600);
    cfsetispeed(&tty, B9600);
    tty.c_cflag |= (CLOCAL | CREAD);    /* ignore modem controls */
    tty.c_cflag &= ~CSIZE;
    tty.c_cflag |= CS8;         /* 8-bit characters */
    tty.c_cflag &= ~PARENB;     /* no parity bit */
    tty.c_cflag &= ~CSTOPB;     /* only need 1 stop bit */
    tty.c_cflag &= ~CRTSCTS;    /* no hardware flowcontrol */
    tty.c_lflag &= ~(ICANON | ECHO | ECHOE | ISIG);
	tty.c_oflag &= ~OPOST;
	//tty.c_oflag = 0;
    if (tcsetattr(fd, TCSANOW, &tty) != 0) {
        printf("Error from tcsetattr: %s\n", strerror(errno));
        return -1;
    }

	tcflush(fd, TCIOFLUSH);

	n = write(fd, "AAAAAA", 6);
	tcdrain(fd);
	usleep(2000000);	//if not wait long sth goes wrong

	n = write(fd, "4", 1);
	tcdrain(fd);
	usleep(2000000);	//if not wait long sth goes wrong
	

	for(i = 0; i < 64; ++i)
	{
		for(j = 0; j < 256; ++j)
			if(j % 2 == 0)
				buf256[j] = 0x00FF & wavebuf[j / 2 + 128 * i];
			else
				buf256[j] = (0xFF00 & wavebuf[j / 2 + 128 * i]) >> 8;
		n = write(fd, buf256, 256);

		tcdrain(fd);
		usleep(100000);
		printf("i=%d", i);
	}

	close(fd);
	return 0;
}

